Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/Algebraic.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/Algebraic.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/Algebraic.cs	(revision 17295)
@@ -0,0 +1,26 @@
+﻿namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  public static class Algebraic {
+    public static T Abs<T>(this T a) where T : IAlgebraicType<T> { a.AssignAbs(a.Clone()); return a; }
+    public static T Neg<T>(this T a) where T : IAlgebraicType<T> { a.AssignNeg(a.Clone()); return a; }
+    public static T Inv<T>(this T a) where T : IAlgebraicType<T> { a.AssignInv(a.Clone()); return a; }
+    public static T Log<T>(this T a) where T : IAlgebraicType<T> { a.AssignLog(a.Clone()); return a; }
+    public static T Exp<T>(this T a) where T : IAlgebraicType<T> { a.AssignExp(a.Clone()); return a; }
+    public static T Sin<T>(this T a) where T : IAlgebraicType<T> { a.AssignSin(a.Clone()); return a; }
+    public static T Cos<T>(this T a) where T : IAlgebraicType<T> { a.AssignCos(a.Clone()); return a; }
+    public static T Sgn<T>(this T a) where T : IAlgebraicType<T> { a.AssignSgn(a.Clone()); return a; }
+    public static T IntPower<T>(this T a, int p) where T : IAlgebraicType<T> { a.AssignIntPower(a.Clone(), p); return a; }
+    public static T IntRoot<T>(this T a, int r) where T : IAlgebraicType<T> { a.AssignIntRoot(a.Clone(), r); return a; }
+
+    internal static T Min<T>(T a, T b) where T : IAlgebraicType<T> { return a.Clone().AssignMin(b); }
+    internal static T Max<T>(T a, T b) where T : IAlgebraicType<T> { return a.Clone().AssignMax(b); }
+
+    // public static T Max<T>(T a, T b) where T : IAlgebraicType<T> {
+    //   // ((a + b) + abs(b - a)) / 2
+    //   return a.Clone().Add(b).Add(b.Clone().Sub(a).Abs()).Scale(1.0 / 2.0);
+    // }
+    // public static T Min<T>(T a, T b) where T : IAlgebraicType<T> {
+    //   // ((a + b) - abs(a - b)) / 2
+    //   return a.Clone().Add(b).Sub(a.Clone().Sub(b).Abs()).Scale(1.0 / 2.0);
+    // }
+  }
+}
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicDouble.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicDouble.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicDouble.cs	(revision 17295)
@@ -0,0 +1,54 @@
+﻿using System;
+using System.Diagnostics;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  // algebraic type wrapper for a double value
+  [DebuggerDisplay("{Value}")]
+  public sealed class AlgebraicDouble : IAlgebraicType<AlgebraicDouble> {
+    public static implicit operator AlgebraicDouble(double value) { return new AlgebraicDouble(value); }
+    public static implicit operator double(AlgebraicDouble value) { return value.Value; }
+    public double Value;
+
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    public AlgebraicDouble Zero => new AlgebraicDouble(0.0);
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    public AlgebraicDouble One => new AlgebraicDouble(1.0);
+
+    public bool IsInfinity => IsNegativeInfinity || IsPositiveInfinity;
+    public bool IsNegativeInfinity => double.IsNegativeInfinity(Value);
+    public bool IsPositiveInfinity => double.IsPositiveInfinity(Value);
+    public AlgebraicDouble() { }
+    public AlgebraicDouble(double value) { this.Value = value; }
+    public AlgebraicDouble Assign(AlgebraicDouble a) { Value = a.Value; return this; }
+    public AlgebraicDouble Add(AlgebraicDouble a) { Value += a.Value; return this; }
+    public AlgebraicDouble Sub(AlgebraicDouble a) { Value -= a.Value; return this; }
+    public AlgebraicDouble Mul(AlgebraicDouble a) { Value *= a.Value; return this; }
+    public AlgebraicDouble Div(AlgebraicDouble a) { Value /= a.Value; return this; }
+    public AlgebraicDouble Scale(double s) { Value *= s; return this; }
+    public AlgebraicDouble AssignInv(AlgebraicDouble a) { Value = 1.0 / a.Value; return this; }
+    public AlgebraicDouble AssignNeg(AlgebraicDouble a) { Value = -a.Value; return this; }
+    public AlgebraicDouble AssignSin(AlgebraicDouble a) { Value = Math.Sin(a.Value); return this; }
+    public AlgebraicDouble AssignCos(AlgebraicDouble a) { Value = Math.Cos(a.Value); return this; }
+    public AlgebraicDouble AssignTanh(AlgebraicDouble a) { Value = Math.Tanh(a.Value); return this; }
+    public AlgebraicDouble AssignLog(AlgebraicDouble a) { Value = Math.Log(a.Value); return this; }
+    public AlgebraicDouble AssignExp(AlgebraicDouble a) { Value = Math.Exp(a.Value); return this; }
+    public AlgebraicDouble AssignIntPower(AlgebraicDouble a, int p) { Value = Math.Pow(a.Value, p); return this; }
+    public AlgebraicDouble AssignIntRoot(AlgebraicDouble a, int r) { Value = IntRoot(a.Value, r); return this; }
+    public AlgebraicDouble AssignMin(AlgebraicDouble other) { Value = Math.Min(Value, other.Value); return this; }
+    public AlgebraicDouble AssignMax(AlgebraicDouble other) { Value = Math.Max(Value, other.Value); return this; }
+
+    // helper
+    private static double IntRoot(double value, int r) {
+      if (r % 2 == 0) return Math.Pow(value, 1.0 / r);
+      else return value < 0 ? -Math.Pow(-value, 1.0 / r) : Math.Pow(value, 1.0 / r);
+    }
+
+    public AlgebraicDouble AssignAbs(AlgebraicDouble a) { Value = Math.Abs(a.Value); return this; }
+    public AlgebraicDouble AssignSgn(AlgebraicDouble a) { Value = double.IsNaN(a.Value) ? double.NaN : Math.Sign(a.Value); return this; }
+    public AlgebraicDouble Clone() { return new AlgebraicDouble(Value); }
+
+    public override string ToString() {
+      return Value.ToString();
+    }
+  }
+}
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicDoubleVector.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicDoubleVector.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicDoubleVector.cs	(revision 17295)
@@ -0,0 +1,85 @@
+﻿using System;
+using System.Diagnostics;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  // a simple vector as an algebraic type
+  [DebuggerDisplay("DoubleVector(len={Length}): {string.}")]
+  public class AlgebraicDoubleVector : IAlgebraicType<AlgebraicDoubleVector> {
+    private double[] arr;
+    public double this[int idx] { get { return arr[idx]; } set { arr[idx] = value; } }
+    public int Length => arr.Length;
+
+    public AlgebraicDoubleVector(int length) { arr = new double[length]; }
+
+    public AlgebraicDoubleVector() { }
+
+    /// <summary>
+    /// 
+    /// </summary>
+    /// <param name="arr">array is not copied</param>
+    public AlgebraicDoubleVector(double[] arr) { this.arr = arr; }
+
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    public AlgebraicDoubleVector Zero => new AlgebraicDoubleVector(new double[this.Length]); // must return vector of same length as this (therefore Zero is not static)
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    public AlgebraicDoubleVector One => new AlgebraicDoubleVector(new double[this.Length]).AssignConstant(1.0); // must return vector of same length as this (therefore Zero is not static)
+    public AlgebraicDoubleVector Assign(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = a.arr[i]; } return this; }
+    public AlgebraicDoubleVector Add(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] += a.arr[i]; } return this; }
+    public AlgebraicDoubleVector Sub(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] -= a.arr[i]; } return this; }
+    public AlgebraicDoubleVector Mul(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] *= a.arr[i]; } return this; }
+    public AlgebraicDoubleVector Div(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] /= a.arr[i]; } return this; }
+    public AlgebraicDoubleVector AssignNeg(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = -a.arr[i]; } return this; }
+    public AlgebraicDoubleVector AssignInv(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = 1.0 / a.arr[i]; } return this; }
+    public AlgebraicDoubleVector Scale(double s) { for (int i = 0; i < arr.Length; ++i) { arr[i] *= s; } return this; }
+    public AlgebraicDoubleVector AssignLog(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Log(a.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignSin(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Sin(a.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignExp(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Exp(a.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignCos(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Cos(a.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignTanh(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Tanh(a.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignIntPower(AlgebraicDoubleVector a, int p) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Pow(a.arr[i], p); } return this; }
+    public AlgebraicDoubleVector AssignIntRoot(AlgebraicDoubleVector a, int r) { for (int i = 0; i < arr.Length; ++i) { arr[i] = IntRoot(a.arr[i], r); } return this; }
+    public AlgebraicDoubleVector AssignMin(AlgebraicDoubleVector other) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Min(arr[i], other.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignMax(AlgebraicDoubleVector other) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Max(arr[i], other.arr[i]); } return this; }
+
+    // helper
+    private double IntRoot(double v, int r) {
+      if (r % 2 == 0) return Math.Pow(v, 1.0 / r);
+      else return v < 0 ? -Math.Pow(-v, 1.0 / r) : Math.Pow(v, 1.0 / r);
+    }
+
+    public AlgebraicDoubleVector AssignAbs(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Abs(a.arr[i]); } return this; }
+    public AlgebraicDoubleVector AssignSgn(AlgebraicDoubleVector a) { for (int i = 0; i < arr.Length; ++i) { arr[i] = Math.Sign(a.arr[i]); } return this; }
+
+    public AlgebraicDoubleVector Clone() {
+      var v = new AlgebraicDoubleVector(this.arr.Length);
+      Array.Copy(arr, v.arr, v.arr.Length);
+      return v;
+    }
+
+    public AlgebraicDoubleVector AssignConstant(double constantValue) {
+      for (int i = 0; i < arr.Length; ++i) {
+        arr[i] = constantValue;
+      }
+      return this;
+    }
+
+    public void CopyTo(double[] dest, int idx, int length) {
+      Array.Copy(arr, 0, dest, idx, length);
+    }
+
+    public void CopyFrom(double[] data, int rowIndex) {
+      Array.Copy(data, rowIndex, arr, 0, Math.Min(arr.Length, data.Length - rowIndex));
+    }
+    public void CopyRowTo(double[,] dest, int row) {
+      for (int j = 0; j < arr.Length; ++j) dest[row, j] = arr[j];
+    }
+
+    internal void CopyColumnTo(double[,] dest, int column, int row, int len) {
+      for (int j = 0; j < len; ++j) dest[row + j, column] = arr[j];
+    }
+
+    public override string ToString() {
+      return "{" + string.Join(", ", arr.Take(Math.Max(5, arr.Length))) + (arr.Length > 5 ? "..." : string.Empty) + "}";
+    }
+  }
+}
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicInterval.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicInterval.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/AlgebraicInterval.cs	(revision 17295)
@@ -0,0 +1,293 @@
+﻿using System;
+using System.Diagnostics;
+using System.Linq;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  // this is our own implementation of interval arithmetic
+  // for a well worked out definition of interval operations for IEEE reals see:
+  // Stahl: Interval Methods for Bounding the Range of Polynomials and Solving Systems of Nonlinear Equations, Dissertation, JKU, 1995
+  [DebuggerDisplay("[{low.Value}..{high.Value}]")]
+  public class AlgebraicInterval : IAlgebraicType<AlgebraicInterval> {
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    private MultivariateDual<AlgebraicDouble> low;
+    public MultivariateDual<AlgebraicDouble> LowerBound => low.Clone();
+
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    private MultivariateDual<AlgebraicDouble> high;
+    public MultivariateDual<AlgebraicDouble> UpperBound => high.Clone();
+
+
+    public AlgebraicInterval() : this(double.NegativeInfinity, double.PositiveInfinity) { }
+
+    public AlgebraicInterval(MultivariateDual<AlgebraicDouble> low, MultivariateDual<AlgebraicDouble> high) {
+      this.low = low.Clone();
+      this.high = high.Clone();
+    }
+
+    public AlgebraicInterval(double low, double high) {
+      this.low = new MultivariateDual<AlgebraicDouble>(new AlgebraicDouble(low));
+      this.high = new MultivariateDual<AlgebraicDouble>(new AlgebraicDouble(high));
+    }
+
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    public AlgebraicInterval Zero => new AlgebraicInterval(0.0, 0.0);
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    public AlgebraicInterval One => new AlgebraicInterval(1.0, 1.0);
+
+    public AlgebraicInterval Add(AlgebraicInterval a) {
+      low.Add(a.low);
+      high.Add(a.high);
+      return this;
+    }
+
+    public AlgebraicInterval Mul(AlgebraicInterval a) {
+      var v1 = low.Clone().Mul(a.low);
+      var v2 = low.Clone().Mul(a.high);
+      var v3 = high.Clone().Mul(a.low);
+      var v4 = high.Clone().Mul(a.high);
+
+      low = Min(Min(v1, v2), Min(v3, v4));
+      high = Max(Max(v1, v2), Max(v3, v4));
+
+      return this;
+    }
+
+
+    private static MultivariateDual<AlgebraicDouble> Min(MultivariateDual<AlgebraicDouble> a, MultivariateDual<AlgebraicDouble> b) {
+      return a.Value < b.Value ? a : b;
+    }
+    private static MultivariateDual<AlgebraicDouble> Max(MultivariateDual<AlgebraicDouble> a, MultivariateDual<AlgebraicDouble> b) {
+      return a.Value > b.Value ? a : b;
+    }
+
+    public AlgebraicInterval Assign(AlgebraicInterval a) {
+      low = a.low;
+      high = a.high;
+      return this;
+    }
+
+    public AlgebraicInterval AssignCos(AlgebraicInterval a) {
+      return AssignSin(a.Clone().Add(new AlgebraicInterval(Math.PI / 2, Math.PI / 2)));
+    }
+
+    public AlgebraicInterval Div(AlgebraicInterval a) {
+      if (a.Contains(0.0)) {
+        if (a.low.Value.Value == 0 && a.high.Value.Value == 0) {
+          if (this.low.Value >= 0) {
+            // pos / 0
+          } else if (this.high.Value <= 0) {
+            // neg / 0
+          } else {
+            low = new MultivariateDual<AlgebraicDouble>(double.NegativeInfinity);
+            high = new MultivariateDual<AlgebraicDouble>(double.PositiveInfinity);
+          }
+        } else if (a.low.Value.Value >= 0) {
+          // a is positive 
+          Mul(new AlgebraicInterval(a.Clone().high.Inv(), new MultivariateDual<AlgebraicDouble>(double.PositiveInfinity)));
+        } else if (a.high.Value <= 0) {
+          // a is negative
+          Mul(new AlgebraicInterval(new MultivariateDual<AlgebraicDouble>(double.NegativeInfinity), a.low.Clone().Inv()));
+        } else {
+          // a is interval over zero
+          low = new MultivariateDual<AlgebraicDouble>(double.NegativeInfinity);
+          high = new MultivariateDual<AlgebraicDouble>(double.PositiveInfinity);
+        }
+      } else {
+        Mul(new AlgebraicInterval(a.high.Clone().Inv(), a.low.Clone().Inv())); // inverting leads to inverse roles of high and low
+      }
+      return this;
+    }
+
+    public AlgebraicInterval AssignExp(AlgebraicInterval a) {
+      low.AssignExp(a.low);
+      high.AssignExp(a.high);
+      return this;
+    }
+
+    // tanh is a bijective function
+    public AlgebraicInterval AssignTanh(AlgebraicInterval a) {
+      low.AssignTanh(a.low);
+      high.AssignTanh(a.high);
+      return this;
+    }
+
+    public AlgebraicInterval AssignIntPower(AlgebraicInterval a, int p) {
+      if (p < 0) {  // x^-3 == 1/(x^3)
+        AssignIntPower(a, -p);
+        return AssignInv(this);
+      } else if (p == 0) {
+        if (a.Contains(0.0)) {
+          // => 0^0 = 0 ; might not be relevant
+          low = new MultivariateDual<AlgebraicDouble>(0.0);
+          high = new MultivariateDual<AlgebraicDouble>(1.0);
+          return this;
+        } else {
+          // => 1
+          low = new MultivariateDual<AlgebraicDouble>(1.0);
+          high = new MultivariateDual<AlgebraicDouble>(1.0);
+          return this;
+        }
+      } else if (p == 1) return this;
+      else if (p % 2 == 0) {
+        // p is even => interval must be positive
+        if (a.Contains(0.0)) {
+          low = new MultivariateDual<AlgebraicDouble>(0.0);
+          high = a.low.IntPower(p).AssignMax(a.high.IntPower(p));
+        } else {
+          var lowPower = a.low.IntPower(p);
+          var highPower = a.high.IntPower(p);
+          low = lowPower.AssignMin(highPower);
+          high = lowPower.AssignMax(highPower);
+        }
+      } else {
+        // p is uneven
+        if (a.Contains(0.0)) {
+          low.AssignIntPower(a.low, p);
+          high.AssignIntPower(a.high, p);
+        } else {
+          var lowPower = a.low.IntPower(p);
+          var highPower = a.high.IntPower(p);
+          low = lowPower.AssignMin(highPower);
+          high = lowPower.AssignMax(highPower);
+        }
+      }
+      return this;
+    }
+
+    public AlgebraicInterval AssignIntRoot(AlgebraicInterval a, int r) {
+      if (r == 0) { low = new MultivariateDual<AlgebraicDouble>(double.NaN); high = new MultivariateDual<AlgebraicDouble>(double.NaN); return this; }
+      if (r == 1) return this;
+      if (r < 0) {
+        // x^ (-1/2) = 1 / (x^(1/2))
+        AssignIntRoot(a, -r);
+        return AssignInv(this);
+      } else {
+        // root only defined for positive arguments for even roots
+        if (r % 2 == 0 && a.LowerBound.Value.Value < 0) {
+          low = new MultivariateDual<AlgebraicDouble>(double.NaN);
+          high = new MultivariateDual<AlgebraicDouble>(double.NaN);
+          return this;
+        } else {
+          low.AssignIntRoot(a.low, r);
+          high.AssignIntRoot(a.high, r);
+          return this;
+        }
+      }
+    }
+
+    public AlgebraicInterval AssignInv(AlgebraicInterval a) {
+      low = new MultivariateDual<AlgebraicDouble>(1.0);
+      high = new MultivariateDual<AlgebraicDouble>(1.0);
+      return Div(a);
+    }
+
+    public AlgebraicInterval AssignLog(AlgebraicInterval a) {
+      low.AssignLog(a.low);
+      high.AssignLog(a.high);
+      return this;
+    }
+
+    public AlgebraicInterval AssignNeg(AlgebraicInterval a) {
+      low.AssignNeg(a.high);
+      high.AssignNeg(a.low);
+      return this;
+    }
+
+    public AlgebraicInterval Scale(double s) {
+      low.Scale(s);
+      high.Scale(s);
+      if (s < 0) {
+        var t = low;
+        low = high;
+        high = t;
+      }
+      return this;
+    }
+
+    public AlgebraicInterval AssignSin(AlgebraicInterval a) {
+      var lower = a.LowerBound.Value.Value;
+      var size = a.UpperBound.Value.Value - lower;
+      if (size < 0) throw new InvalidProgramException(); // ASSERT interval >= 0;
+
+      if (size >= Math.PI * 2) {
+        low = new MultivariateDual<AlgebraicDouble>(-1.0); // zero gradient
+        high = new MultivariateDual<AlgebraicDouble>(1.0);
+        return this;
+      }
+
+      // assume low and high are in the same quadrant
+      low = Algebraic.Min(a.LowerBound.Clone().Sin(), a.UpperBound.Clone().Sin());
+      high = Algebraic.Max(a.LowerBound.Clone().Sin(), a.UpperBound.Clone().Sin());
+
+      // override min and max if necessary
+
+      // shift interval 'a' into the range [-2pi .. 2pi] without changing the size of the interval to simplify the checks
+      lower = lower % (2 * Math.PI); // lower in [-2pi .. 2pi]      
+
+      // handle min = -1 and max = 1 cases explicitly
+      var pi_2 = Math.PI / 2.0;
+      var maxima = new double[] { -3 * pi_2, pi_2 };
+      var minima = new double[] { -pi_2, 3 * pi_2 };
+
+      // override min and max if necessary
+      if (maxima.Any(m => lower < m && lower + size > m)) {
+        // max = 1
+        high = new MultivariateDual<AlgebraicDouble>(1.0); // zero gradient
+      }
+
+      if (minima.Any(m => lower < m && lower + size > m)) {
+        // min = -1;
+        low = new MultivariateDual<AlgebraicDouble>(-1.0); // zero gradient
+      }
+      return this;
+    }
+
+    public AlgebraicInterval Sub(AlgebraicInterval a) {
+      // [x1,x2] − [y1,y2] = [x1 − y2,x2 − y1]
+      low.Sub(a.high);
+      high.Sub(a.low);
+      return this;
+    }
+
+    public AlgebraicInterval Clone() {
+      return new AlgebraicInterval(low, high);
+    }
+
+    public bool Contains(double val) {
+      return LowerBound.Value.Value <= val && val <= UpperBound.Value.Value;
+    }
+
+    public AlgebraicInterval AssignAbs(AlgebraicInterval a) {
+      if (a.Contains(0.0)) {
+        var abslow = a.low.Clone().Abs();
+        var abshigh = a.high.Clone().Abs();
+        a.high.Assign(Algebraic.Max(abslow, abshigh));
+        a.low.Assign(new MultivariateDual<AlgebraicDouble>(0.0)); // lost gradient for lower bound
+      } else {
+        var abslow = a.low.Clone().Abs();
+        var abshigh = a.high.Clone().Abs();
+        a.low.Assign(Algebraic.Min(abslow, abshigh));
+        a.high.Assign(Algebraic.Max(abslow, abshigh));
+      }
+      return this;
+    }
+
+    public AlgebraicInterval AssignSgn(AlgebraicInterval a) {
+      low.AssignSgn(a.low);
+      high.AssignSgn(a.high);
+      return this;
+    }
+
+    public AlgebraicInterval AssignMin(AlgebraicInterval other) {
+      low.AssignMin(other.low);
+      high.AssignMin(other.high);
+      return this;
+    }
+
+    public AlgebraicInterval AssignMax(AlgebraicInterval other) {
+      low.AssignMax(other.low);
+      high.AssignMax(other.high);
+      return this;
+    }
+  }
+}
